#ifndef VHTTPD_CONNECTION_H
#define VHTTPD_CONNECTION_H

#include <vhttpd/channel.h>
#include <vhttpd/http_message.h>

typedef struct connection_t connection_t;
typedef message_t *(*connection_handler_t) (retcode_t, const message_t *, void*);

connection_t *connection_new (channel_t *, connection_handler_t, void*);
void connection_delete (connection_t *);

channel_t *connection_get_channel (connection_t *);
int connection_is_open (connection_t *);

int connection_send_message (connection_t *, const message_t *);
retcode_t connection_receive_message (connection_t *, message_t *);
void connection_read (connection_t *);

#endif
