#ifndef VHTTPD_SERVER_H
#define VHTTPD_SERVER_H

#include <vhttpd/channel.h>
#include <vhttpd/http_connection.h>

typedef struct server_t server_t;


server_t *create_server_from_socket (int socket_fd);
server_t *create_tls_server_from_socket (int socket_fd, const char *keyfile, const char *certfile);
server_t *create_smart_server_from_socket (int socket_fd, const char *keyfile, const char *certfile);

server_t * create_inet_server (const char *addr, const char* port);
server_t * create_unix_server (const char *path);
server_t * create_tls_server (const char *addr, const char* port, const char *keyfile, const char *certfile);
server_t * create_smart_server (const char *addr, const char* port, const char *keyfile, const char *certfile);

void destroy_server (server_t *);
void server_loop (server_t *, connection_handler_t, void*);

#endif
