#ifndef TLS_CHANNEL_PRIVATE_H
#define TLS_CHANNEL_PRIVATE_H

#include "private.h"
#include "channel_private.h"

typedef struct tls_channel_t
{
    channel_t base;

    tls_ctx_t *ctx;
    tls_session_t *session;

} tls_channel_t;

#define TLS_CHANNEL_T(p) ((tls_channel_t *)(p))

channel_t *tls_channel_accept (channel_t * c);
int tls_channel_send (channel_t * c, const char *buf, size_t len);
int tls_channel_sendfile (channel_t * c, int fd, size_t len);
int tls_channel_receive (channel_t * c, buffer_t *buf);
void destroy_tls_channel (channel_t * c);

tls_session_t *tls_channel_session (channel_t * c);
tls_ctx_t *tls_channel_ctx (channel_t * c);

#endif /* TLS_CHANNEL_PRIVATE_H */
